﻿/*
COPYRIGHT (C) 2011-2013 Raynald Messié

THIS FILE IS PART OF SCRUMPILOT.

SCRUMPILOT IS FREE SOFTWARE: YOU CAN REDISTRIBUTE IT AND/OR MODIFY IT UNDER THE TERMS OF 
THE GNU LESSER GENERAL PUBLIC LICENSE VERSION v2.1 AS PUBLISHED BY THE FREE SOFTWARE FOUNDATION.

SCRUMPILOT IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT WITHOUT ANY WARRANTY; WITHOUT
EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU LESSER
GENERAL PUBLIC LICENSE FOR MORE DETAILS.

YOU SHOULD HAVE RECEIVED A COPY OF THE GNU LESSER GENERAL PUBLIC LICENSE ALONG WITH SCRUMPILOT. 
IF NOT, SEE <HTTP://WWW.GNU.ORG/LICENSES/>.
*/

using System;
using System.Collections.Generic;
using System.Linq;

namespace ScrumPilot.Domain.Repositories
{
    public class ProjectRepository : RepositoryBase<project>
    {
        public ProjectRepository(DBScrumPilotEntities context) : base(context) { }

        public List<project> GetProjectPaged(int page, int rows, out int totalCount)
        {
            totalCount = DataContext.projects.Count();
            return DataContext.projects.OrderBy(c => c.name).Skip(page * rows).Take(rows).ToList();
        }

        public List<project> GetFollowedProject()
        {
            return DataContext.projects.Where(p => !p.notuse).ToList();
        }

        public Int32[] GetFollowedProjectId()
        {
            return DataContext.projects.Where(p => !p.notuse).Select(p => p.projectid).ToArray();
        }

        public IDictionary<int, string> GetFollowedProjectDictionary()
        {
            return DataContext.projects.Where(p => !p.notuse).ToDictionary(prj => prj.projectid, prj => prj.currentsprint);
        }
    }
}
