﻿/*
COPYRIGHT (C) 2011-2013 Raynald Messié

THIS FILE IS PART OF SCRUMPILOT.

SCRUMPILOT IS FREE SOFTWARE: YOU CAN REDISTRIBUTE IT AND/OR MODIFY IT UNDER THE TERMS OF 
THE GNU LESSER GENERAL PUBLIC LICENSE VERSION v2.1 AS PUBLISHED BY THE FREE SOFTWARE FOUNDATION.

SCRUMPILOT IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT WITHOUT ANY WARRANTY; WITHOUT
EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU LESSER
GENERAL PUBLIC LICENSE FOR MORE DETAILS.

YOU SHOULD HAVE RECEIVED A COPY OF THE GNU LESSER GENERAL PUBLIC LICENSE ALONG WITH SCRUMPILOT. 
IF NOT, SEE <HTTP://WWW.GNU.ORG/LICENSES/>.
*/

using System.Collections.Generic;
using System.Web.Mvc;
using ScrumPilot.Domain.BPL;
using ScrumPilot.Domain.Models;
using ScrumPilot.Helpers;
using ScrumPilot.Models;

namespace ScrumPilot.Controllers
{
    [Authorize]
    public class KanbanController : BaseController
    {
        private KanbanServices _ksm;
        protected KanbanServices KanbanSrv { get { return _ksm ?? (_ksm = new KanbanServices(this.TFS)); } }

        [HttpGet]
        public ActionResult Index()
        {
            List<Project> selected, unselected;

            KanbanSrv.GetAllOtherIterations(out selected, out unselected);
            return View(new KanbanViewModels
            {
                SelectedProjects = selected,
                UnselectedProjects = unselected
            });
        }

        [HttpGet]
        public EmptyResult UpdateIteration(int way, int id, int projectId)
        {
            KanbanSrv.UpdateKanbanIteration(way,id,projectId);
            return null;
        }

    }
}
