/*
COPYRIGHT (C) 2011-2013 Raynald Messi

THIS FILE IS PART OF SCRUMPILOT.

SCRUMPILOT IS FREE SOFTWARE: YOU CAN REDISTRIBUTE IT AND/OR MODIFY IT UNDER THE TERMS OF 
THE GNU LESSER GENERAL PUBLIC LICENSE VERSION v2.1 AS PUBLISHED BY THE FREE SOFTWARE FOUNDATION.

SCRUMPILOT IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT WITHOUT ANY WARRANTY; WITHOUT
EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU LESSER
GENERAL PUBLIC LICENSE FOR MORE DETAILS.

YOU SHOULD HAVE RECEIVED A COPY OF THE GNU LESSER GENERAL PUBLIC LICENSE ALONG WITH SCRUMPILOT. 
IF NOT, SEE <HTTP://WWW.GNU.ORG/LICENSES/>.
*/

/// <reference path="Commons/Base.ts" />

class KanbanIndex extends Base.Page {
    Ready() {
        var mainDiv = $("#selected, #unselected");
        // Init JQueryUI Sortable
        mainDiv.sortable({
            connectWith: ".connectedSortable",
            dropOnEmpty: true,
            receive: this.SortableReceiveItem
        }).disableSelection();
        // Init dbl click event (a like draggable)
        mainDiv.find("li").each(function () {
            $(this).dblclick(function () => {
                var actorPart: number = (($(this).parent())[0].id == "selected") ? 1 : 0;
                return Base.Page.Self.ReceiveItem(this, actorPart,
                    function () => {
                        // remove from source
                        $(this).remove();
                        // insert in target
                        $((actorPart == 0) ? "#selected" : "#unselected").append(this);
                        // Refresh for see changed
                        mainDiv.sortable('refresh');
                    });
            });
        })
    }

    // Draggable event
    private SortableReceiveItem(event: any, ui: any) {
        var actorPart: number = -1;
        if (event.target.id == "selected")
            actorPart = 0;
        else if (event.target.id == "unselected")
            actorPart = 1;
        else // If receiver is unkown
            return false;
        return (Base.Page.Self.ReceiveItem(ui.item[0], actorPart));
    }

    // Main event > call ajax to set Kanban Iteration
    private ReceiveItem(item: any, actorPart: number, callBack?: any): void {
        // Fire and forget
        $.getJSON(Base.Page.Self.aUrl[0],
        {
            way: actorPart,
            id: item.id,
            projectId: $(item).attr('data-projectid')
        },
        callBack && callBack()
        );
    }
}