/*
COPYRIGHT (C) 2011-2013 Raynald Messi

THIS FILE IS PART OF SCRUMPILOT.

SCRUMPILOT IS FREE SOFTWARE: YOU CAN REDISTRIBUTE IT AND/OR MODIFY IT UNDER THE TERMS OF 
THE GNU LESSER GENERAL PUBLIC LICENSE VERSION v2.1 AS PUBLISHED BY THE FREE SOFTWARE FOUNDATION.

SCRUMPILOT IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT WITHOUT ANY WARRANTY; WITHOUT
EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU LESSER
GENERAL PUBLIC LICENSE FOR MORE DETAILS.

YOU SHOULD HAVE RECEIVED A COPY OF THE GNU LESSER GENERAL PUBLIC LICENSE ALONG WITH SCRUMPILOT. 
IF NOT, SEE <HTTP://WWW.GNU.ORG/LICENSES/>.
*/

/// <reference path="Commons/Base.ts" />
declare var isChecked: any;
declare var setScore: any;

class TasksList extends Base.Page {
    Ready() {
        // init checkBoxes
        CallService("GET", this.aUrl[5], null, true, function (msg) {
            var fields = new Array("todochk", "progresschk", "donechk", "reopenchk", "unestimatedchk", "taskflt", "bugflt");
            for (var i = 0; i < fields.length; i++) {
                $('#' + fields[i]).attr('checked', msg[i]).click(
                    function () {
                        return  Base.Page.Self.FilterView(this.id);
                    });
            }
        });
        // init select
        $("#projectsFilter").multiselect({
            noneSelectedText: 'selection',
            minWidth: 50,
            classes: 'projectFilter',
            //  hide: ["highlight", 800],
            close: function () {
                CallService("POST", "FilterByProject", { myprojects: $('select#projectsFilter').val() }, true, function () {
                     Base.Page.Self.refreshTaskList();
                });
            }
        }).multiselectfilter();
        this.refreshTaskList();
    }

    refreshTaskList() {
        return this.loadTaskList(this.aUrl[1], this.aUrl[0], this.aUrl[2], this.aUrl[3]);
    }

    private loadTaskList(urlContent: string, url: string, urlEdit: string, urlLoading: string): void {
        CallService('GET', url, {}, true, function (data) {
            LoadHtmlAndTemplate(urlContent, 'MainTasksList', data, true, function () {
                $('.setScore').click(function () {
                    var id: number = $(this).attr('data-id');
                    var score: number = $(this).attr('data-score');
                    Base.Page.Self.SetScore(id, score);
                });
                $('.taskAction').click(function () {
                    var id: number = $(this).attr('data-id');
                    var type: number = $(this).attr('data-type');
                    Base.Page.Self.TaskAction(id, type);
                });

                $('button.buttonClose').button({
                    icons: {
                        primary: "ui-icon-close"
                    },
                    text: false
                });
                $('button.setbutton').button({
                    icons: {
                        primary: "ui-icon-circle-check"
                    },
                    text: false
                });
                $('.edit').editable(urlEdit, {
                    indicator: '<img src="' + urlLoading + '">',
                    tooltip: "Doubleclick to edit...",
                    event: "dblclick",
                    callback: function () { }
                });
                $('.editarea').editable(urlEdit, {
                    type: "autogrow",
                    submit: "Save",
                    indicator: '<img src="' + urlLoading + '">',
                    tooltip: "Doubleclick to edit descriptions...",
                    event: "dblclick",
                    autogrow: {
                        lineHeight: 16,
                        maxHeight: 512
                    },
                    callback: function () { }
                });

            });
        });
    }

    FilterView(id: string): void {
        CallService("POST", this.aUrl[4], { key: id, data: isChecked("#" + id) }, true, function () {
            Base.Page.Self.refreshTaskList();
        });
    }

    TaskAction(id: number, typeAction: number): void {
        CallService("POST", this.aUrl[6], { id: id, typeAction: typeAction }, true, function () {
            Base.Page.Self.refreshTaskList();
        });
    }

    SetScore(id: number, score: number): void {
        setScore(id, score, this.aUrl[7]);
    }

    EditDialogComplete(): void {
        this.refreshTaskList();
        $.unblockUI();
        $('#dialog-score').dialog('close');
    }

    showMove(id: number) {
        BlockUi();
        $("#dialog-move").empty();
        return $.ajax({
            url: this.aUrl[8],
            data: { id: id },
            success: function (htmldata) {
                $('#dialog-move').html(htmldata);
                $.unblockUI();
                $('#dialog-move').dialog(
                    {
                        autoOpen: false,
                        width: 500,
                        modal: true,
                        hide: "highlight",
                        buttons: {
                            Cancel: function () { $(this).dialog("close"); },
                            "Save": function () { $("#MoveForm").submit(); }
                        }
                    }).dialog('open');
            }
        });
    }

    initProjectsList() {
        CallService("POST", "FilterByProject", { myprojects: $('select#projectsFilter').val() }, true, function () {
            Base.Page.Self.refreshTaskList();
        });
    }
}