/*
COPYRIGHT (C) 2011-2013 Raynald Messi

THIS FILE IS PART OF SCRUMPILOT.

SCRUMPILOT IS FREE SOFTWARE: YOU CAN REDISTRIBUTE IT AND/OR MODIFY IT UNDER THE TERMS OF 
THE GNU LESSER GENERAL PUBLIC LICENSE VERSION v2.1 AS PUBLISHED BY THE FREE SOFTWARE FOUNDATION.

SCRUMPILOT IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT WITHOUT ANY WARRANTY; WITHOUT
EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU LESSER
GENERAL PUBLIC LICENSE FOR MORE DETAILS.

YOU SHOULD HAVE RECEIVED A COPY OF THE GNU LESSER GENERAL PUBLIC LICENSE ALONG WITH SCRUMPILOT. 
IF NOT, SEE <HTTP://WWW.GNU.ORG/LICENSES/>.
*/

/// <reference path="Commons/Base.ts" />

class UsersList extends Base.Page {
    Ready() {
        var urlSetFilter: string = this.aUrl[0];
        var urlCheck: string = this.aUrl[1];
        var urlSync: string = this.aUrl[2];
        $(this.options.isFiltered == 1 ? "#radio1" : "#radio2").attr("checked", "checked");
        $("#radio1,#radio2").click(function () {
            CallService("GET", urlSetFilter, { type: this.value }, true, function () { window.location.reload(true); });
        });
        $("#checkusers").click(function () {
            return Base.Page.Self.dialogCheckUsers(urlCheck, urlSync);
        });
        $.templates({
            WorkItemTemplate: "<a href='{{:Url}}' target='_blank' data-content='{{:Content}}'>{{:Title}}</a>&nbsp;&nbsp;"
        });

        // userlinecontent
        $.each($(".userlinecontent"), function () {
            var userId: number = $(this).attr("data-index");
            CallService("GET", Base.Page.Self.aUrl[3], { id: userId }, true, function (data: any) {
                if (data) {
                    Base.Page.Self.SetWorkItemLine(data.UserStories, userId, "#imgldw_", "#wip_");
                    Base.Page.Self.SetWorkItemLine(data.Tasks, userId, "#imglts_", "#lts_");
                    Base.Page.Self.SetWorkItemLine(data.Bugs, userId, "#imglbg_", "#lbg_");
                    Base.Page.Self.SetWorkItemLine(data.CheckOuts, userId, "#imgldp_", "#pcs_");
                    $("#score_" + userId).empty().append(data.Score);
                    $("#hours_" + userId).empty().append(data.Hours);
                    $("#tasks_" + userId).empty().append(data.OpenTasks + '/' + data.TotalTasks);

                }
            });
        });
    }

    SetWorkItemLine(data: any, userId: number, imgName: string, elementName: string): void {
        var content: string = "<em>No work item</em>";
        if (data && data.length > 0) {
            content = $.render.WorkItemTemplate(data);
        }
        $(imgName + userId).hide();
        $(elementName + userId).empty().append(content);
    }

    dialogCheckUsers(urlCheck, urlSync) {
        $("<div></div>").dialog({
            title: "Check user",
            resizable: false,
            modal: true,
            width: 350,
            height: 250,
            buttons: {
                close: function () {
                    $(this).dialog("close");
                },
                "Apply": function () {
                    var dlg = $(this);
                    dlg.html('<center style="margin-top:70px"><span>Processing... </span><img  src="' + g_ImgDirectory + 'ajax-loader-l.gif" alt="Loading..."/></center>');
                    CallService("POST", urlSync, null, true, function () { dlg.dialog("close"); window.location.reload(true); });
                }
            },
            closeOnEscape: false,
            open: function () {
                var dlg = $(this);
                dlg.html('<center id="chkusr" style="margin-top:70px"><span>Checking users... </span><img  src="' + g_ImgDirectory + 'ajax-loader-l.gif" alt="Loading..."/></center>');
                CallService("GET", urlCheck, null, true, function (data) {
                    $("#chkusr").hide();
                    if (data > 0) {
                        dlg.html('<center style="margin-top:60px"> There is possibly <b>' + data + ' changes </b>between Scrumpilot users and TFS users. Click on Apply to synchronise them.</center>');
                    }
                    else {
                        dlg.html('<center style="margin-top:70px">No change</center>');
                    }
                });
            }
        });
    }
}